/*
Copyright © 2003,
Center for Intelligent Information Retrieval,
University of Massachusetts, Amherst.
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.

3. The names "Center for Intelligent Information Retrieval" and
"University of Massachusetts" must not be used to endorse or promote products
derived from this software without prior written permission. To obtain
permission, contact info@ciir.cs.umass.edu.

THIS SOFTWARE IS PROVIDED BY UNIVERSITY OF MASSACHUSETTS AND OTHER CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/
/* This is a java version of Bob Krovetz' KStem.
 *
 * Java version by Sergio Guzman-Lara.
 * CIIR-UMass Amherst http://ciir.cs.umass.edu
 */
package org.apache.lucene.analysis.en;

/** A list of words used by Kstem
 */
class KStemData5 {
    private KStemData5() {
    }
   static String[] data = {
"lock","locker","locket","lockjaw","locknut",
"lockout","locks","locksmith","lockstitch","lockup",
"loco","locomotion","locomotive","locum","locus",
"locust","locution","lode","lodestar","lodestone",
"lodge","lodgement","lodger","lodging","lodgings",
"lodgment","loess","loft","lofted","lofty",
"log","loganberry","logarithm","logarithmic","logbook",
"logger","loggerheads","loggia","logic","logical",
"logically","logician","logistic","logistics","logjam",
"logrolling","loin","loincloth","loins","loiter",
"loll","lollipop","lollop","lolly","lone",
"lonely","loner","lonesome","long","longboat",
"longbow","longevity","longhaired","longhand","longheaded",
"longhop","longing","longish","longitude","longitudinal",
"longship","longshoreman","longsighted","longstanding","longstop",
"longsuffering","longueur","longways","longwearing","longwinded",
"longwise","loo","loofa","loofah","look",
"looker","lookout","looks","loom","loon",
"loony","loop","loophole","loose","loosebox",
"loosen","loot","lop","lope","loppings",
"loquacious","loquat","lord","lordly","lords",
"lordship","lore","lorgnette","lorn","lorry",
"lose","loser","loss","lost","lot",
"loth","lotion","lottery","lotto","lotus",
"loud","loudhailer","loudmouth","loudspeaker","lough",
"lounge","lounger","lour","louse","lousy",
"lout","louver","louvre","lovable","love",
"loveable","lovebird","lovechild","loveless","lovelorn",
"lovely","lovemaking","lover","lovers","lovesick",
"lovey","loving","low","lowborn","lowbred",
"lowbrow","lowdown","lower","lowermost","lowland",
"lowlander","lowly","loyal","loyalist","loyalty",
"lozenge","lsd","ltd","lubber","lubricant",
"lubricate","lubricator","lubricious","lucerne","lucid",
"luck","luckless","lucky","lucrative","lucre",
"ludicrous","ludo","luff","lug","luggage",
"lugger","lughole","lugsail","lugubrious","lugworm",
"lukewarm","lull","lullaby","lumbago","lumbar",
"lumber","lumberjack","lumberman","lumberyard","luminary",
"luminous","lumme","lummox","lummy","lump",
"lumpish","lumpy","lunacy","lunar","lunate",
"lunatic","lunch","lunchtime","lung","lunge",
"lungfish","lungpower","lupin","lurch","lure",
"lurgy","lurid","lurk","luscious","lush",
"lust","luster","lustful","lustre","lustrous",
"lusty","lutanist","lute","lutenist","luv",
"luxuriant","luxuriate","luxurious","luxury","lychee",
"lychgate","lye","lymph","lymphatic","lynch",
"lynx","lyre","lyrebird","lyric","lyrical",
"lyricism","lyricist","lyrics","mac","macabre",
"macadam","macadamise","macadamize","macaroni","macaroon",
"macaw","mace","macerate","mach","machete",
"machiavellian","machination","machine","machinegun","machinery",
"machinist","mackerel","mackintosh","macrobiotic","macrocosm",
"mad","madam","madame","madcap","madden",
"maddening","madder","made","madeira","mademoiselle",
"madhouse","madly","madman","madness","madonna",
"madrigal","maelstrom","maenad","maestro","mafia",
"mag","magazine","magenta","maggot","maggoty",
"magi","magic","magical","magician","magisterial",
"magistracy","magistrate","magma","magnanimity","magnanimous",
"magnate","magnesia","magnesium","magnet","magnetic",
"magnetise","magnetism","magnetize","magneto","magnificat",
"magnification","magnificent","magnifier","magnify","magniloquent",
"magnitude","magnolia","magnum","magpie","magus",
"maharaja","maharajah","maharanee","maharani","mahatma",
"mahlstick","mahogany","mahout","maid","maiden",
"maidenhair","maidenhead","maidenhood","maidenly","maidservant",
"mail","mailbag","mailbox","maim","main",
"mainland","mainline","mainly","mainmast","mains",
"mainsail","mainspring","mainstay","mainstream","maintain",
"maintenance","maisonette","maisonnette","maize","majestic",
"majesty","majolica","major","majordomo","majorette",
"majority","make","maker","makeshift","making",
"makings","malachite","maladjusted","maladministration","maladroit",
"malady","malaise","malapropism","malapropos","malaria",
"malarial","malay","malcontent","malcontented","male",
"malediction","malefactor","maleficent","malevolent","malfeasance",
"malformation","malformed","malfunction","malice","malicious",
"malign","malignancy","malignant","malignity","malinger",
"mall","mallard","malleable","mallet","mallow",
"malmsey","malnutrition","malodorous","malpractice","malt",
"malthusian","maltreat","maltster","mama","mamba",
"mambo","mamma","mammal","mammary","mammon",
"mammoth","mammy","man","manacle","manage",
"manageable","management","manager","manageress","managerial",
"manatee","mandarin","mandate","mandatory","mandible",
"mandolin","mandrake","mandrill","maneuver","maneuverable",
"manful","manganese","mange","manger","mangle",
"mango","mangosteen","mangrove","mangy","manhandle",
"manhole","manhood","manhour","mania","maniac",
"maniacal","manic","manicure","manicurist","manifest",
"manifestation","manifesto","manifold","manikin","manila",
"manilla","manipulate","manipulation","mankind","manly",
"manna","manned","mannequin","manner","mannered",
"mannerism","mannerly","manners","mannikin","mannish",
"manoeuverable","manoeuvre","manometer","manor","manorial",
"manpower","mansard","manse","manservant","mansion",
"mansions","manslaughter","mantelpiece","mantelshelf","mantilla",
"mantis","mantle","mantrap","manual","manufacture",
"manufacturer","manumit","manure","manuscript","manx",
"many","maoism","maori","map","maple",
"mapping","maquis","mar","marabou","marabout",
"maraschino","marathon","maraud","marble","marbled",
"marbles","marc","marcasite","march","marchioness",
"margarine","margin","marginal","marguerite","marigold",
"marihuana","marijuana","marimba","marina","marinade",
"marinate","marine","mariner","marionette","marital",
"maritime","marjoram","mark","markdown","marked",
"marker","market","marketeer","marketer","marketing",
"marketplace","marking","marksman","marksmanship","markup",
"marl","marlinespike","marmalade","marmoreal","marmoset",
"marmot","marocain","maroon","marquee","marquess",
"marquetry","marquis","marriage","marriageable","married",
"marrow","marrowbone","marrowfat","marry","mars",
"marsala","marseillaise","marsh","marshal","marshmallow",
"marshy","marsupial","mart","marten","martial",
"martian","martin","martinet","martini","martinmas",
"martyr","martyrdom","marvel","marvellous","marvelous",
"marxism","marzipan","mascara","mascot","masculine",
"masculinity","maser","mash","mashie","mask",
"masked","masochism","mason","masonic","masonry",
"masque","masquerade","mass","massacre","massage",
"masses","masseur","massif","massive","massy",
"mast","mastectomy","master","masterful","masterly",
"mastermind","masterpiece","mastership","masterstroke","mastery",
"masthead","mastic","masticate","mastiff","mastitis",
"mastodon","mastoid","mastoiditis","masturbate","mat",
"matador","match","matchbox","matching","matchless",
"matchlock","matchmaker","matchstick","matchwood","mate",
"material","materialise","materialism","materialist","materialize",
"maternal","maternity","matey","mathematician","mathematics",
"matins","matriarch","matriarchy","matricide","matriculate",
"matrimony","matrix","matron","matronly","matt",
"matter","matting","mattins","mattock","mattress",
"maturation","mature","maturity","maudlin","maul",
"maulstick","maunder","mausoleum","mauve","maverick",
"maw","mawkish","maxi","maxim","maximal",
"maximise","maximize","maximum","may","maybe",
"maybeetle","mayday","mayfly","mayhem","mayonnaise",
"mayor","mayoralty","mayoress","maypole","mayst",
"maze","mazed","mazurka","mccarthyism","mead",
"meadow","meadowsweet","meager","meagre","meal",
"mealie","mealtime","mealy","mealybug","mean",
"meander","meanderings","meaning","meaningful","meaningless",
"means","meant","meantime","meanwhile","measles",
"measly","measurable","measure","measured","measureless",
"measurement","meat","meatball","meaty","mecca",
"mechanic","mechanical","mechanics","mechanise","mechanism",
"mechanistic","mechanize","medal","medalist","medallion",
"medallist","meddle","meddlesome","media","mediaeval",
"medial","median","mediate","medic","medical",
"medicament","medicare","medicate","medication","medicinal",
"medicine","medico","medieval","mediocre","mediocrity",
"meditate","meditation","meditative","mediterranean","medium",
"medlar","medley","meed","meek","meerschaum",
"meet","meeting","meetinghouse","megadeath","megahertz",
"megalith","megalithic","megalomania","megalomaniac","megaphone",
"megaton","megrim","meiosis","melancholia","melancholic",
"melancholy","meld","melee","meliorate","meliorism",
"mellifluous","mellow","melodic","melodious","melodrama",
"melodramatic","melody","melon","melt","melting",
"member","membership","membrane","membranous","memento",
"memo","memoir","memoirs","memorabilia","memorable",
"memorandum","memorial","memorise","memorize","memory",
"memsahib","men","menace","menagerie","mend",
"mendacious","mendacity","mendelian","mendicant","mending",
"menfolk","menial","meningitis","meniscus","menopause",
"menses","menstrual","menstruate","mensurable","mensuration",
"mental","mentality","menthol","mentholated","mention",
"mentor","menu","meow","mephistopheles","mercantile",
"mercenary","mercer","mercerise","mercerize","merchandise",
"merchant","merchantman","merciful","merciless","mercurial",
"mercury","mercy","mere","merely","meretricious",
"merge","merger","meridian","meridional","meringue",
"merino","merit","meritocracy","meritorious","mermaid",
"merman","merriment","merry","merrymaking","mesa",
"mescalin","mescaline","mesdames","mesdemoiselles","meseems",
"mesh","mesmeric","mesmerise","mesmerism","mesmerist",
"mesmerize","mess","message","messenger","messiah",
"messianic","messieurs","messmate","messrs","messuage",
"messy","mestizo","met","metabolic","metabolise",
"metabolism","metabolize","metacarpal","metal","metalanguage",
"metallic","metallurgist","metallurgy","metalwork","metamorphose",
"metamorphosis","metaphor","metaphorical","metaphysics","metatarsal",
"mete","metempsychosis","meteor","meteoric","meteorite",
"meteoroid","meteorologist","meteorology","meter","methane",
"methinks","method","methodical","methodism","methodology",
"meths","methuselah","meticulous","metre","metric",
"metrical","metrication","metricise","metricize","metro",
"metronome","metropolis","metropolitan","mettle","mettlesome",
"mew","mews","mezzanine","mezzo","mezzotint",
"miaow","miasma","mica","mice","michaelmas",
"mick","mickey","microbe","microbiologist","microbiology",
"microcosm","microelectronics","microfiche","microfilm","micromesh",
"micrometer","micron","microorganism","microphone","microscope",
"microscopic","microsecond","microwave","mid","midair",
"midcourse","midday","midden","middle","middlebrow",
"middleman","middleweight","middling","midge","midget",
"midi","midland","midlands","midmost","midnight",
"midpoint","midriff","midshipman","midships","midst",
"midsummer","midway","midweek","midwest","midwicket",
"midwife","midwifery","mien","miffed","might",
"mightily","mighty","mignonette","migraine","migrant",
"migrate","migration","migratory","mikado","mike",
"milady","mild","mildew","mildly","mile",
"mileage","mileometer","miler","milestone","milieu",
"militancy","militant","militarise","militarism","militarize",
"military","militate","militia","militiaman","milk",
"milker","milkmaid","milkman","milksop","milkweed",
"milky","mill","millboard","milldam","millenarian",
"millenium","millepede","miller","millet","millibar",
"milligram","milligramme","milliliter","millilitre","millimeter",
"millimetre","milliner","millinery","million","millionaire",
"millipede","millpond","millrace","millstone","millwheel",
"millwright","milometer","milord","milt","mime",
"mimeograph","mimetic","mimic","mimicry","mimosa",
"min","minaret","minatory","mince","mincemeat",
"mincer","mincingly","mind","minded","mindful",
"mindless","mine","minefield","minelayer","miner",
"mineral","mineralogist","mineralogy","minestrone","minesweeper",
"mingle","mingy","mini","miniature","miniaturist",
"minibus","minim","minimal","minimise","minimize",
"minimum","mining","minion","minister","ministerial",
"ministrant","ministration","ministry","miniver","mink",
"minnow","minor","minority","minotaur","minster",
"minstrel","minstrelsy","mint","minuet","minus",
"minuscule","minute","minutely","minuteman","minutes",
"minutia","minx","miracle","miraculous","mirage",
"mire","mirror","mirth","miry","misadventure",
"misadvise","misalliance","misanthrope","misanthropy","misapplication",
"misapply","misapprehend","misapprehension","misappropriate","misbegotten",
"misbehave","misbehaved","misbehavior","misbehaviour","miscalculate",
"miscall","miscarry","miscast","miscegenation","miscellaneous",
"miscellany","mischance","mischief","mischievous","misconceive",
"misconception","misconduct","misconstruction","misconstrue","miscount",
"miscreant","miscue","misdate","misdeal","misdeed",
"misdemeanor","misdemeanour","misdirect","misdoing","miser",
"miserable","miserably","miserly","misery","misfire",
"misfit","misfortune","misgiving","misgovern","misguide",
"misguided","mishandle","mishap","mishear","mishit",
"mishmash","misinform","misinterpret","misjudge","misjudgement",
"misjudgment","mislay","mislead","mismanage","mismatch",
"misname","misnomer","misogynist","misogyny","misplace",
"misprint","mispronounce","mispronunciation","misquote","misread",
"misreport","misrepresent","misrule","miss","missal",
"misshapen","missile","missing","mission","missionary",
"missis","missive","misspell","misspend","misstate",
"misstatement","missus","missy","mist","mistake",
"mistaken","mister","mistime","mistletoe","mistral",
"mistranslate","mistress","mistrial","mistrust","mistrustful",
"mists","misty","misunderstand","misunderstanding","misuse",
"mite","miter","mitigate","mitosis","mitre",
"mitt","mitten","mix","mixed","mixer",
"mixture","mizen","mizzen","mizzenmast","mizzle",
"mnemonic","mnemonics","moa","moan","moat",
"moated","mob","mobile","mobilisation","mobilise",
"mobility","mobilization","mobilize","mobster","moccasin",
"mocha","mock","mockers","mockery","mockingbird",
"modal","mode","model","moderate","moderately",
"moderation","moderations","moderato","moderator","modern",
"modernise","modernism","modernistic","modernity","modernize",
"modest","modesty","modicum","modification","modifier",
"modify","modish","mods","modular","modulate",
"modulation","module","moggy","mogul","moh",
"mohair","mohammedan","mohammedanism","moiety","moist",
"moisten","moisture","moisturise","moisturize","moke",
"molar","molasses","mold","molder","molding",
"moldy","mole","molecular","molecule","molehill",
"moleskin","molest","moll","mollify","mollusc",
"mollusk","mollycoddle","molt","molten","molto",
"molybdenum","mom","moment","momentarily","momentary",
"momentous","moments","momentum","momma","mommy",
"monarch","monarchic","monarchism","monarchist","monarchy",
"monastery","monastic","monasticism","monaural","monday",
"monetary","money","moneybags","moneybox","moneychanger",
"moneyed","moneylender","moneymaker","moneys","monger",
"mongol","mongolism","mongoose","mongrel","monies",
"monitor","monk","monkey","mono","monochrome",
"monocle","monogamous","monogamy","monogram","monograph",
"monolith","monolithic","monolog","monologue","monomania",
"monomaniac","mononucleosis","monophonic","monophthong","monoplane",
"monopolise","monopolist","monopolize","monopoly","monorail",
"monosyllabic","monosyllable","monotheism","monotone","monotonous",
"monotony","monotype","monoxide","monsieur","monsignor",
"monsoon","monster","monstrance","monstrosity","monstrous",
"montage","month","monthly","monument","monumental",
"monumentally","moo","mooch","moocow","mood",
"moody","moon","moonbeam","mooncalf","moonlight",
"moonlit","moonshine","moonstone","moonstruck","moony",
"moor","moorhen","moorings","moorish","moorland",
"moose","moot","mop","mope","moped",
"moppet","moquette","moraine","moral","morale",
"moralise","moralist","moralistic","morality","moralize",
"morally","morals","morass","moratorium","morbid",
"morbidity","mordant","more","morello","moreover",
"mores","moresque","morganatic","morgue","moribund",
"mormon","mormonism","morn","morning","mornings",
"morocco","moron","moronic","morose","morpheme",
"morphemics","morpheus","morphine","morphology","morrow",
"morsel","mortal","mortality","mortally","mortar",
"mortarboard","mortgage","mortgagee","mortgagor","mortice",
"mortician","mortification","mortify","mortise","mortuary",
"mosaic","moselle","mosey","moslem","mosque",
"mosquito","moss","mossy","most","mostly",
"mote","motel","motet","moth","mothball",
"mothballs","mother","motherhood","motherly","mothproof",
"motif","motion","motionless","motions","motivate",
"motivation","motive","motley","motocross","motor",
"motorbike","motorboat","motorcade","motorcar","motorcycle",
"motorcyclist","motoring","motorise","motorist","motorize",
"motorman","motorway","mottled","motto","mould",
"moulder","moulding","mouldy","moult","mound",
"mount","mountain","mountaineer","mountaineering","mountainous",
"mountainside","mountaintop","mountebank","mountie","mourn",
"mourner","mournful","mourning","mouse","mouser",
"mousetrap","moussaka","mousse","moustache","mousy",
"mouth","mouthful","mouthorgan","mouthpiece","mouthwash",
"movable","move","moveable","movement","movements",
"mover","movie","movies","moving","mow",
"mower","mpg","mph","mra","mrs",
"msc","much","muchness","mucilage","muck",
"muckheap","muckrake","mucky","mucous","mucus",
"mud","muddle","muddy","mudflat","mudguard",
"mudpack","mudslinger","muesli","muezzin","muff",
"muffin","muffle","muffler","mufti","mug",
"mugger","muggins","muggy","mugwump","muhammadan",
"muhammadanism","mulatto","mulberry","mulch","mulct",
"mule","muleteer","mulish","mull","mullah",
"mullet","mulligatawny","mullion","mullioned","multifarious",
"multiform","multilateral","multilingual","multimillionaire","multiple",
"multiplex","multiplication","multiplicity","multiply","multiracial",
"multistorey","multitude","multitudinous","mum","mumble",
"mummer","mummery","mummify","mumming","mummy",
"mumps","munch","mundane","municipal","municipality",
"munificence","munificent","muniments","munition","munitions",
"mural","murder","murderous","murk","murky",
"murmur","murphy","murrain","muscatel","muscle",
"muscled","muscleman","muscovite","muscular","muse",
"museum","mush","mushroom","mushy","music",
"musical","musically","musician","musicianship","musk",
"musket","musketeer","musketry","muskmelon","muskrat",
"musky","muslim","muslin","musquash","muss",
"mussel","must","mustache","mustachio","mustang",
"mustard","muster","musty","mutable","mutant",
"mutation","mute","muted","mutilate","mutilation",
"mutineer","mutinous","mutiny","mutt","mutter",
"mutton","muttonchops","mutual","mutuality","muzak",
"muzzle","muzzy","mycology","myelitis","myna",
"mynah","myopia","myriad","myrrh","myrtle",
"myself","mysterious","mystery","mystic","mystical",
"mysticism","mystification","mystify","mystique","myth",
"mythical","mythological","mythologist","mythology","myxomatosis",
"nab","nabob","nacelle","nacre","nadir",
"nag","naiad","nail","nailbrush","naive",
"naivete","naivety","naked","name","namedrop",
"nameless","namely","nameplate","namesake","nanny",
"nap","napalm","naphtha","naphthalene","napkin",
"nappy","narc","narcissism","narcissus","narcotic",
"nark","narky","narrate","narration","narrative",
"narrator","narrow","narrowly","narrows","narwhal",
"nasal","nasalise","nasalize","nascent","nasturtium",
"nasty","natal","nation","national","nationalise",
"nationalism","nationalist","nationalistic","nationality","nationalize",
"nationwide","native","nativity","nato","natter",
"natty","natural","naturalise","naturalism","naturalist",
"naturalistic","naturalize","naturally","naturalness","nature",
"naturism","naturopath","naught","naughty","nausea",
"nauseate","nauseous","nautch","nautical","nautilus",
"naval","nave","navel","navigable","navigate",
"navigation","navigator","navvy","navy","nay",
"nazi","nco","neanderthal","neapolitan","near",
"nearby","nearly","nearside","nearsighted","neat",
"nebula","nebular","nebulous","necessaries","necessarily",
"necessary","necessitate","necessitous","necessity","neck",
"neckband","neckerchief","necklace","necklet","neckline",
"necktie","neckwear","necromancer","necromancy","necrophilia",
"necrophiliac","necropolis","nectar","nectarine","need",
"needful","needle","needless","needlessly","needlewoman",
"needlework","needs","needy","nefarious","negate",
"negative","neglect","neglectful","negligee","negligence",
"negligent","negligible","negotiable","negotiate","negotiation",
"negress","negro","negus","neigh","neighbor",
"neighborhood","neighboring","neighborly","neighbour","neighbourhood",
"neighbouring","neighbourly","neither","nelson","nemesis",
"neoclassical","neocolonialism","neolithic","neologism","neon",
"neonate","neophyte","neoplasm","nephew","nephritis",
"nepotism","neptune","nereid","nerve","nerveless",
"nerves","nervous","nervy","ness","nest",
"nesting","nestle","nestling","nestor","net",
"netball","nether","nethermost","nets","nett",
"netting","nettle","network","neural","neuralgia",
"neurasthenia","neurasthenic","neuritis","neurologist","neurology",
"neurosis","neurotic","neuter","neutral","neutralise",
"neutrality","neutralize","neutralizer","neutron","never",
"nevermore","nevertheless","new","newborn","newcomer",
"newel","newfangled","newfoundland","newly","newlywed",
"newmarket","news","newsagent","newsboy","newscast",
"newscaster","newsletter","newsmonger","newspaper","newsprint",
"newsreel","newsroom","newssheet","newsstand","newsvendor",
"newsworthy","newsy","newt","newtonian","next",
"nexus","nhs","niacin","nib","nibble",
"niblick","nibs","nice","nicely","nicety",
"niche","nick","nickel","nicker","nicknack",
"nickname","nicotine","niece","niff","nifty",
"niggard","niggardly","nigger","niggle","niggling",
"nigh","night","nightcap","nightclothes","nightclub",
"nightdress","nightfall","nighthawk","nightingale","nightjar",
"nightlife","nightlight","nightline","nightlong","nightly",
"nightmare","nights","nightshade","nightshirt","nightstick",
"nighttime","nihilism","nilotic","nimble","nimbus",
"nimrod","nincompoop","nine","ninepin","ninepins",
"nines","nineteen","ninety","ninny","ninth",
"nip","nipper","nippers","nipping","nipple",
"nippy","nirvana","nisi","nit","niter",
"nitpick","nitpicking","nitrate","nitre","nitric",
"nitrochalk","nitrogen","nitroglycerin","nitroglycerine","nitrous",
"nitwit","nix","nob","nobble","nobility",
"noble","nobleman","nobly","nobody","nocturnal",
"nocturne","nod","nodal","noddle","nodular",
"nodule","noel","noes","nog","noggin",
"nohow","noise","noisome","noisy","nomad",
"nomadic","nomenclature","nominal","nominate","nomination",
"nominative","nominee","nonage","nonagenarian","nonaggression",
"nonaligned","nonalignment","nonassertive","nonce","nonchalance",
"nonchalant","noncombatant","noncommittal","nonconductor","nonconformist",
"nonconformity","noncontributory","nondescript","none","nonentity",
"nonesuch","nonetheless","nonfiction","nonflammable","nonintervention",
"nonobservance","nonpareil","nonpayment","nonplus","nonproliferation",
"nonresident","nonrestrictive","nonsense","nonsensical","nonskid",
"nonsmoker","nonstandard","nonstarter","nonstick","nonstop",
"nonunion","nonverbal","nonviolence","nonviolent","nonwhite",
"noodle","nook","noon","noonday","noose",
"nope","nor","nordic","norm","normal",
"normalise","normality","normalize","normally","norman",
"normative","north","northbound","northeast","northeaster",
"northeasterly","northeastern","northeastward","northeastwards","northerly",
"northern","northerner","northernmost","northward","northwards",
"northwest","northwester","northwesterly","northwestern","northwestward",
"northwestwards","nos","nose","nosebag","nosebleed",
"nosecone","nosedive","nosegay","nosey","nosh",
"nostalgia","nostril","nostrum","nosy","not",
"notability","notable","notably","notarise","notarize",
"notary","notation","notch","note","notebook",
"notecase","noted","notepaper","noteworthy","nothing",
"nothingness","notice","noticeable","notifiable","notification",
"notify","notion","notional","notions","notoriety",
"notorious","notwithstanding","nougat","nought","noun",
"nourish","nourishment","nous","nova","novel",
"novelette","novelettish","novelist","novella","novelty",
"november","novice","noviciate","novitiate","novocaine",
"now","nowadays","nowhere","nowise","noxious",
"nozzle","nth","nuance","nub","nubile",
"nuclear","nucleus","nude","nudge","nudism",
"nudity","nugatory","nugget","nuisance","null",
"nullah","nullify","nullity","numb","number",
"numberless","numberplate","numbers","numbly","numbskull",
"numeracy","numeral","numerate","numeration","numerator",
"numerical","numerology","numerous","numinous","numismatic",
"numismatics","numskull","nun","nuncio","nunnery",
"nuptial","nuptials","nurse","nurseling","nursemaid",
"nursery","nurseryman","nursing","nursling","nurture",
"nut","nutcase","nutcracker","nuthouse","nutmeg",
"nutria","nutrient","nutriment","nutrition","nutritious",
"nutritive","nuts","nutshell","nutty","nuzzle",
"nylon","nylons","nymph","nymphet","nymphomania",
"nymphomaniac","oaf","oak","oaken","oakum",
"oap","oar","oarlock","oarsman","oarsmanship",
"oasis","oat","oatcake","oath","oatmeal",
"oats","obbligato","obdurate","obeah","obedient",
"obeisance","obelisk","obese","obey","obfuscate",
"obituary","object","objection","objectionable","objective",
"objector","oblation","obligate","obligation","obligatory",
"oblige","obliging","oblique","obliterate","oblivion",
"oblivious","oblong","obloquy","obnoxious","oboe",
"oboist","obscene","obscenity","obscurantism","obscure",
"obscurity","obsequies","obsequious","observable","observance",
"observant","observation","observations","observatory","observe",
"observer","observing","obsess","obsession","obsessional",
"obsessive","obsidian","obsolescent","obsolete","obstacle",
"obstetrician","obstetrics","obstinate","obstreperous","obstruct",
"obstruction","obstructionism","obstructive","obtain","obtainable",
"obtrude","obtrusive","obtuse","obverse","obviate",
"obvious","obviously","ocarina","occasion","occasional",
"occident","occidental","occult","occupancy","occupant",
"occupation","occupational","occupier","occupy","occur",
"occurrence","ocean","oceangoing","oceanography","ocelot",
"ocher","ochre","octagon","octane","octave",
"octavo","octet","october","octogenarian","octopus",
"octosyllabic","ocular","oculist","odalisque","odd",
"oddball","oddity","oddly","oddment","odds",
"ode","odious","odium","odor","odoriferous",
"odorous","odour","odyssey","oecumenical","oecumenicalism",
"oesophagus","oestrogen","off","offal","offbeat",
"offence","offend","offender","offense","offensive",
"offer","offering","offertory","offhand","office",
"officeholder","officer","offices","official","officialdom",
"officialese","officially","officiate","officious","offing",
"offish","offprint","offset","offshoot","offshore",
"offside","offspring","offstage","oft","often",
"ogle","ogre","ohm","oho","oil",
"oilcake","oilcan","oilcloth","oiled","oilfield",
"oilman","oilrig","oils","oilskin","oilskins",
"oily","oink","ointment","okapi","okay",
"okra","old","olden","oldish","oldster",
"oleaginous","oleander","oleograph","olfactory","oligarch",
"oligarchy","olive","olympiad","olympian","olympic",
"ombudsman","omega","omelet","omelette","omen",
"ominous","omission","omit","omnibus","omnipotent",
"omnipresent","omniscient","omnivorous","once","oncoming",
"one","onerous","oneself","onetime","ongoing",
"onion","onlooker","only","onomatopoeia","onrush",
"onset","onshore","onside","onslaught","onto",
"ontology","onus","onward","onwards","onyx",
"oodles","oof","oomph","oops","ooze",
"opacity","opal","opalescent","opaque","ope",
"open","opencast","opener","openhearted","opening",
"openly","openwork","opera","operable","operate",
"operation","operational","operative","operator","operetta",
"ophthalmia","ophthalmic","ophthalmology","ophthalmoscope","opiate",
"opine","opinion","opinionated","opium","opossum",
"opponent","opportune","opportunism","opportunity","oppose",
"opposite","opposition","oppress","oppression","oppressive",
"oppressor","opprobrious","opprobrium","ops","opt",
"optative","optic","optical","optician","optics",
"optimism","optimum","option","optional","opulence",
"opulent","opus","oracle","oracular","oral",
"orange","orangeade","orangeman","orangutang","oration",
"orator","oratorical","oratorio","oratory","orb",
"orbit","orchard","orchestra","orchestral","orchestrate",
"orchid","ordain","ordeal","order","ordered",
"orderly","orders","ordinal","ordinance","ordinand",
"ordinarily","ordinary","ordinate","ordination","ordnance",
"ordure","ore","oregano","organ","organdie",
"organdy","organic","organisation","organise","organised",
"organism","organist","organization","organize","organized",
"orgasm","orgiastic","orgy","orient","oriental",
"orientalist","orientate","orientation","orifice","origin",
"original","originality","originally","originate","oriole",
"orison","orlon","ormolu","ornament","ornamental",
"ornamentation","ornate","ornery","ornithology","orotund",
"orphan","orphanage","orrery","orrisroot","orthodontic",
"orthodontics","orthodox","orthodoxy","orthography","orthopaedic",
"orthopaedics","orthopedic","orthopedics","ortolan","oryx",
"oscar","oscillate","oscillation","oscillator","oscillograph",
"oscilloscope","osculation","osier","osmosis","osprey",
"osseous","ossification","ossify","ostensible","ostentation",
"osteoarthritis","osteopath","osteopathy","ostler","ostracise",
"ostracize","ostrich","other","otherwise","otherworldly",
"otiose","otter","ottoman","oubliette","ouch",
"ought","ounce","our","ours","ourselves",
"ousel","oust","out","outback","outbalance",
"outbid","outbound","outbrave","outbreak","outbuilding",
"outburst","outcast","outcaste","outclass","outcome",
"outcrop","outcry","outdated","outdistance","outdo",
"outdoor","outdoors","outer","outermost","outface",
"outfall","outfield","outfight","outfit","outflank",
"outflow","outfox","outgeneral","outgoing","outgoings",
"outgrow","outgrowth","outhouse","outing","outlandish",
"outlast","outlaw","outlay","outlet","outline",
"outlive","outlook","outlying","outmaneuver","outmanoeuvre",
"outmarch","outmatch","outmoded","outmost","outnumber",
"outpatient","outplay","outpoint","outpost","outpourings",
"output","outrage","outrageous","outrange","outrank",
"outride","outrider","outrigger","outright","outrival",
"outrun","outsell","outset","outshine","outside",
"outsider","outsize","outskirts","outsmart","outspoken",
"outspread","outstanding","outstay","outstretched","outstrip",
"outtalk","outvote","outward","outwardly","outwards",
"outwear","outweigh","outwit","outwork","outworn",
"ouzel","ouzo","ova","oval","ovarian",
"ovary","ovation","oven","ovenware","over",
"overact","overage","overall","overalls","overarch",
"overarm","overawe","overbalance","overbear","overbearing",
"overbid","overblown","overboard","overburden","overcall",
"overcapitalise","overcapitalize","overcast","overcharge","overcloud",
"overcoat","overcome","overcompensate","overcrop","overcrowd",
"overdevelop","overdo","overdone","overdose","overdraft",
"overdraw","overdrawn","overdress","overdrive","overdue",
"overestimate","overexpose","overflow","overfly","overgrown",
"overgrowth","overhand","overhang","overhaul","overhead",
"overheads","overhear","overjoyed","overkill","overland",
"overlap","overlay","overleaf","overleap","overload",
"overlong","overlook","overlord","overly","overman",
"overmaster","overmuch","overnight","overpass","overpay",
"overplay","overpopulated","overpopulation","overpower","overpowering",
"overprint","overrate","overreach","override","overriding",
"overrule","overrun","overseas","oversee","overseer",
"oversell","oversexed","overshadow","overshoe","overshoot",
"overside","oversight","oversimplify","oversleep","overspill",
"overstate","overstatement","overstay","oversteer","overstep",
"overstock","overstrung","overstuffed","oversubscribed","overt",
"overtake","overtax","overthrow","overtime","overtone",
"overtones","overtop","overtrump","overture","overtures",
"overturn","overweening","overweight","overwhelm","overwhelming",
"overwork","overwrought","oviduct","oviparous","ovoid",
"ovulate","ovum","owe","owl","owlet",
"owlish","own","owner","ownership","oxbridge",
"oxcart","oxeye","oxide","oxidise","oxidize",
"oxon","oxonian","oxtail","oxyacetylene","oxygen",
"oxygenate","oyez","oyster","oystercatcher","ozone",
"pabulum","pace","pacemaker","pacesetter","pachyderm",
"pacific","pacifier","pacifism","pacifist","pacify",
"pack","package","packed","packer","packet",
"packing","packsaddle","pact","pad","padding",
"paddle","paddock","paddy","padlock","padre",
"paean","paederast","paederasty","paediatrician","paediatrics",
"paella","paeony","pagan","paganism","page",
"pageant","pageantry","pagination","pagoda","paid",
"pail","paillasse","pain","pained","painful",
"painkiller","painless","pains","painstaking","paint",
"paintbrush","painter","painting","paints","paintwork",
"pair","paisley","pajama","pajamas","pal",
"palace","paladin","palais","palakeen","palanquin",
"palatable","palatal","palatalize","palate","palatial",
"palatinate","palaver","pale","paleface","paleography",
"paleolithic","paleontology","palette","palfrey","palimpsest",
"palindrome","paling","palings","palisade","palish",
"pall","palladian","pallbearer","pallet","palliasse",
"palliate","palliation","palliative","pallid","pallor",
"pally","palm","palmer","palmetto","palmist",
"palmistry","palmy","palomino","palpable","palpate",
"palpitate","palpitation","palsied","palsy","palter",
"paltry","pampas","pamper","pamphlet","pamphleteer",
"pan","panacea","panache","panama","panatela",
"panatella","pancake","panchromatic","pancreas","panda",
"pandemic","pandemonium","pander","pandit","panegyric",
"panel","paneling","panelist","panelling","panellist",
"pang","panhandle","panic","panicky","panjabi",
"panjandrum","pannier","pannikin","panoplied","panoply",
"panorama","panpipes","pansy","pant","pantaloon",
"pantaloons","pantechnicon","pantheism","pantheon","panther",
"panties","pantile","panto","pantograph","pantomime",
"pantry","pants","panty","panzer","pap",
"papa","papacy","papadum","papal","papaya",
"paper","paperback","paperboy","paperhanger","papers",
"paperweight","paperwork","papery","papist","papoose",
"pappy","paprika","papyrus","par","parable",
"parabola","parachute","parachutist","paraclete","parade",
"paradigm","paradigmatic","paradise","paradisiacal","paradox",
"paraffin","paragon","paragraph","parakeet","parallel",
"parallelism","parallelogram","paralyse","paralysis","paralytic",
"paralyze","paramilitary","paramount","paramountcy","paramour",
"paranoia","paranoiac","paranoid","parapet","paraphernalia",
"paraphrase","paraplegia","paraplegic","paraquat","paras",
"parasite","parasitic","parasol","parathyroid","paratrooper",
"paratroops","paratyphoid","parboil","parcel","parch",
"parchment","pard","pardon","pardonable","pardonably",
"pardoner","pare","parent","parentage","parental",
"parenthesis","parenthetic","parenthood","parer","parhelion",
"pariah","paring","parish","parishioner","parisian",
"parity","park","parka","parkin","parking",
"parkland","parky","parlance","parley","parliament",
"parliamentarian","parliamentary","parlor","parlour","parlous",
"parmesan","parochial","parodist","parody","parole",
"paroxysm","parquet","parr","parricide","parrot",
"parry","parse","parsee","parsi","parsimonious",
"parsimony","parsley","parsnip","parson","parsonage",
"part","partake","parterre","parthenogenesis","partial",
"partiality","partially","participant","participate","participation",
"participial","participle","particle","particular","particularise",
"particularity","particularize","particularly","particulars","parting",
"partisan","partita","partition","partitive","partizan",
"partly","partner","partnership","partook","partridge",
"parts","parturition","party","parvenu","paschal",
"pasha","pass","passable","passage","passageway",
"passbook","passenger","passerby","passim","passing",
"passion","passionate","passionately","passionflower","passive",
"passivity","passivize","passkey","passover","passport",
"password","past","pasta","paste","pasteboard",
"pastel","pastern","pasteurise","pasteurize","pastiche",
"pastille","pastime","pasting","pastor","pastoral",
"pastorale","pastorate","pastrami","pastry","pasturage",
"pasture","pasty","pat","patch","patchouli",
"patchwork","patchy","patella","patent","patentee",
"patently","pater","paterfamilias","paternal","paternalism",
"paternity","paternoster","path","pathan","pathetic",
"pathfinder","pathological","pathologist","pathology","pathos",
"pathway","patience","patient","patina","patio",
"patisserie","patois","patrial","patriarch","patriarchal",
"patriarchate","patriarchy","patrician","patricide","patrimony",
"patriot","patriotic","patriotism","patrol","patrolman",
"patron","patronage","patroness","patronise","patronize",
"patronymic","patten","patter","pattern","patty",
"paucity","paunch","paunchy","pauper","pauperise",
"pauperism","pauperize","pause","pavan","pavane",
"pave","paved","pavement","pavilion","paving",
"paw","pawky","pawl","pawn","pawnbroker",
"pawnshop","pawpaw","pay","payable","payday",
"payee","payer","payload","paymaster","payment",
"paynim","payoff","payola","payroll","pea",
"peace","peaceable","peaceful","peacekeeping","peacemaker",
"peacetime","peach","peachick","peacock","peafowl",
"peahen","peak","peaked","peaky","peal",
"peanut","peanuts","pear","pearl","pearly",
"pearmain","peasant","peasantry","peashooter","peat",
"pebble","pebbledash","pebbly","pecan","peccadillo",
"peccary","peck","pecker","peckish","pectic",
"pectin","pectoral","peculate","peculiar","peculiarity",
"peculiarly","pecuniary","pedagogue","pedagogy","pedal",
};
}
