/*
Copyright © 2003,
Center for Intelligent Information Retrieval,
University of Massachusetts, Amherst.
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.

3. The names "Center for Intelligent Information Retrieval" and
"University of Massachusetts" must not be used to endorse or promote products
derived from this software without prior written permission. To obtain
permission, contact info@ciir.cs.umass.edu.

THIS SOFTWARE IS PROVIDED BY UNIVERSITY OF MASSACHUSETTS AND OTHER CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/
/* This is a java version of Bob Krovetz' KStem.
 *
 * Java version by Sergio Guzman-Lara.
 * CIIR-UMass Amherst http://ciir.cs.umass.edu
 */
package org.apache.lucene.analysis.en;

/** A list of words used by Kstem
 */
class KStemData6 {
    private KStemData6() {
    }
   static String[] data = {
"pedant","pedantic","pedantry","peddle","peddler",
"pederast","pederasty","pedestal","pedestrian","pediatrician",
"pediatrics","pedicab","pedicel","pedicure","pedigree",
"pediment","pedlar","pedometer","pee","peek",
"peekaboo","peel","peeler","peelings","peep",
"peeper","peephole","peepul","peer","peerage",
"peeress","peerless","peeve","peevish","peewit",
"peg","pejorative","pekinese","pekingese","pekoe",
"pelagic","pelf","pelican","pellagra","pellet",
"pellucid","pelmet","pelota","pelt","pelvic",
"pelvis","pemican","pemmican","pen","penal",
"penalise","penalize","penalty","penance","pence",
"penchant","pencil","pendant","pendent","pending",
"pendulous","pendulum","penetrate","penetrating","penetration",
"penetrative","penguin","penicillin","peninsula","penis",
"penitent","penitential","penitentiary","penknife","penmanship",
"pennant","penniless","pennon","penny","pennyweight",
"pennywort","penology","pension","pensionable","pensioner",
"pensive","pentagon","pentagram","pentameter","pentateuch",
"pentathlon","pentecost","penthouse","penultimate","penumbra",
"penurious","penury","peon","peony","people",
"pep","pepper","peppercorn","peppermint","peppery",
"pepsin","peptic","per","peradventure","perambulate",
"perambulator","perceive","percentage","percentile","perceptible",
"perception","perceptive","perch","perchance","percipient",
"percolate","percolator","percussion","percussionist","perdition",
"peregrination","peremptory","perennial","perfect","perfectible",
"perfection","perfectionist","perfectly","perfidious","perfidy",
"perforate","perforation","perforce","perform","performance",
"performer","perfume","perfumier","perfunctory","pergola",
"perhaps","perigee","perihelion","peril","perilous",
"perimeter","period","periodic","periodical","periods",
"peripatetic","peripheral","periphery","periphrasis","periphrastic",
"periscope","perish","perishable","perisher","perishing",
"peristyle","peritonitis","periwig","periwinkle","perjure",
"perjurer","perjury","perk","perky","perm",
"permafrost","permanence","permanency","permanent","permanganate",
"permeable","permeate","permissible","permission","permissive",
"permit","permutation","permute","pernicious","pernickety",
"pernod","peroration","peroxide","perpendicular","perpetrate",
"perpetual","perpetuate","perpetuity","perplex","perplexed",
"perplexity","perquisite","perry","persecute","persecution",
"perseverance","persevere","persevering","persian","persiflage",
"persimmon","persist","persistence","persistent","persnickety",
"person","persona","personable","personage","personal",
"personalise","personalities","personality","personalize","personally",
"personification","personify","personnel","perspective","perspex",
"perspicacious","perspiration","perspire","persuade","persuasion",
"persuasive","pert","pertain","pertinacious","pertinent",
"perturb","perturbation","peruke","peruse","pervade",
"pervasive","perverse","perversion","perversity","pervert",
"peseta","pesky","peso","pessary","pessimism",
"pessimist","pest","pester","pesticide","pestiferous",
"pestilence","pestilent","pestle","pet","petal",
"petaled","petalled","petard","peterman","petite",
"petition","petitioner","petrel","petrifaction","petrify",
"petrochemical","petrol","petroleum","petrology","petticoat",
"pettifogging","pettish","petty","petulant","petunia",
"pew","pewit","pewter","peyote","pfennig",
"phaeton","phagocyte","phalanx","phalarope","phallic",
"phallus","phantasmagoria","phantasmal","phantasy","phantom",
"pharaoh","pharisaic","pharisee","pharmaceutical","pharmacist",
"pharmacology","pharmacopoeia","pharmacy","pharyngitis","pharynx",
"phase","phd","pheasant","phenobarbitone","phenol",
"phenomenal","phenomenally","phenomenon","phew","phi",
"phial","philander","philanthropic","philanthropist","philanthropy",
"philatelist","philately","philharmonic","philhellene","philippic",
"philistine","philological","philologist","philology","philosopher",
"philosophical","philosophise","philosophize","philosophy","philter",
"philtre","phizog","phlebitis","phlebotomy","phlegm",
"phlegmatic","phlox","phobia","phoenician","phoenix",
"phone","phoneme","phonemic","phonemics","phonetic",
"phonetician","phonetics","phoney","phonic","phonics",
"phonograph","phonology","phony","phooey","phosphate",
"phosphorescence","phosphorescent","phosphoric","phosphorus","photo",
"photocopier","photocopy","photoelectric","photogenic","photograph",
"photographer","photographic","photography","photosensitive","photosensitize",
"photostat","photosynthesis","phototsensitise","phrasal","phrase",
"phrasebook","phraseology","phrenetic","phrenology","phthisis",
"phut","phylloxera","phylum","physic","physical",
"physically","physician","physicist","physics","physio",
"physiognomy","physiology","physiotherapy","physique","pianissimo",
"pianist","piano","pianola","piaster","piastre",
"piazza","pibroch","picador","picaresque","piccalilli",
"piccaninny","piccolo","pick","pickaback","pickaninny",
"pickax","pickaxe","picked","picker","pickerel",
"picket","pickings","pickle","pickled","pickpocket",
"picky","picnic","picnicker","pictorial","picture",
"pictures","picturesque","piddle","piddling","pidgin",
"pie","piebald","piece","piecemeal","pieces",
"piecework","piecrust","pied","pier","pierce",
"piercing","pierrot","piety","piezoelectric","piffle",
"piffling","pig","pigeon","pigeonhole","piggery",
"piggish","piggy","piggyback","piggybank","pigheaded",
"piglet","pigment","pigmentation","pigmy","pignut",
"pigskin","pigsticking","pigsty","pigswill","pigtail",
"pike","pikestaff","pilaster","pilau","pilchard",
"pile","piles","pileup","pilfer","pilferage",
"pilgrim","pilgrimage","pill","pillage","pillar",
"pillbox","pillion","pillock","pillory","pillow",
"pillowcase","pilot","pimento","pimp","pimpernel",
"pimple","pin","pinafore","pincer","pincers",
"pinch","pinchbeck","pinched","pinchpenny","pincushion",
"pine","pineal","pineapple","pinecone","pinewood",
"piney","ping","pinhead","pinion","pink",
"pinkeye","pinkie","pinkish","pinko","pinky",
"pinnace","pinnacle","pinnate","pinny","pinpoint",
"pinprick","pinstripe","pint","pinta","pintable",
"pinup","pinwheel","piny","pioneer","pious",
"piousness","pip","pipal","pipe","pipeline",
"piper","pipes","pipette","piping","pipit",
"pippin","pipsqueak","piquant","pique","piquet",
"piracy","piranha","pirate","pirouette","piscatorial",
"pish","piss","pissed","pistachio","pistil",
"pistol","piston","pit","pitch","pitchblende",
"pitcher","pitchfork","piteous","pitfall","pith",
"pithead","pithy","pitiable","pitiful","pitiless",
"pitman","piton","pittance","pituitary","pity",
"pivot","pivotal","pixie","pixilated","pixy",
"pizza","pizzicato","placard","placate","place",
"placebo","placed","placekick","placement","placenta",
"placid","placket","plagarise","plagarize","plagiarism",
"plague","plaguey","plaice","plaid","plain",
"plainly","plainsman","plainsong","plainspoken","plaint",
"plaintiff","plaintive","plait","plan","planchette",
"planet","planetarium","planetary","plangent","plank",
"planking","plankton","planner","plant","plantain",
"plantation","planter","plaque","plash","plasma",
"plaster","plasterboard","plastered","plasterer","plastering",
"plastic","plasticine","plasticity","plastics","plastron",
"plate","plateau","platelayer","platform","plating",
"platinum","platitude","platonic","platoon","platter",
"platypus","plaudit","plausible","play","playable",
"playback","playbill","playboy","player","playful",
"playgoer","playground","playgroup","playhouse","playmate",
"playpen","playroom","playsuit","plaything","playtime",
"playwright","plaza","plea","pleach","plead",
"pleading","pleadings","pleasant","pleasantry","please",
"pleased","pleasing","pleasurable","pleasure","pleat",
"pleb","plebeian","plebiscite","plectrum","pled",
"pledge","pleistocene","plenary","plenipotentiary","plenitude",
"plenteous","plentiful","plenty","pleonasm","plethora",
"pleurisy","plexus","pliable","pliant","pliers",
"plight","plimsoll","plinth","pliocene","plod",
"plodder","plonk","plop","plosive","plot",
"plough","ploughboy","ploughman","ploughshare","plover",
"plow","plowboy","plowman","plowshare","ploy",
"pluck","plucky","plug","plughole","plum",
"plumage","plumb","plumbago","plumber","plumbing",
"plume","plumed","plummet","plummy","plump",
"plunder","plunge","plunger","plunk","pluperfect",
"plural","pluralism","plurality","pluribus","plus",
"plush","plushy","pluto","plutocracy","plutocrat",
"plutonium","ply","plywood","pneumatic","pneumoconiosis",
"pneumonia","poach","poacher","pock","pocked",
"pocket","pocketbook","pocketful","pocketknife","pockmark",
"pockmarked","pod","podgy","podiatry","podium",
"poem","poesy","poet","poetaster","poetess",
"poetic","poetical","poetry","pogrom","poignancy",
"poignant","poinsettia","point","pointed","pointer",
"pointillism","pointless","points","pointsman","poise",
"poised","poison","poisonous","poke","poker",
"pokerwork","poky","polack","polar","polarisation",
"polarise","polarity","polarization","polarize","polaroid",
"polaroids","polder","pole","poleax","poleaxe",
"polecat","polemic","polemical","polemics","police",
"policeman","policewoman","policy","polio","polish",
"polisher","politburo","polite","politic","politicalise",
"politicalize","politician","politicise","politicize","politicking",
"politico","politics","polity","polka","poll",
"pollard","pollen","pollinate","polling","pollster",
"pollutant","pollute","pollution","polly","pollyanna",
"polo","polonaise","polony","poltergeist","poltroon",
"poly","polyandrous","polyandry","polyanthus","polyester",
"polyethylene","polygamist","polygamous","polygamy","polyglot",
"polygon","polymath","polymer","polymorphous","polyp",
"polyphony","polypus","polystyrene","polysyllable","polytechnic",
"polytheism","polythene","polyurethane","pomade","pomander",
"pomegranate","pomeranian","pommel","pommy","pomp",
"pompom","pomposity","pompous","ponce","poncho",
"poncy","pond","ponder","ponderous","pone",
"pong","poniard","pontiff","pontifical","pontificals",
"pontificate","pontoon","pony","ponytail","pooch",
"poodle","poof","pooh","pool","poolroom",
"pools","poop","pooped","poor","poorhouse",
"poorly","poorness","poove","pop","popadam",
"popadum","popcorn","popery","popgun","popinjay",
"popish","poplar","poplin","poppa","popper",
"poppet","poppy","poppycock","popshop","popsy",
"populace","popular","popularise","popularity","popularize",
"popularly","populate","population","populism","populist",
"populous","porcelain","porch","porcine","porcupine",
"pore","pork","porker","porky","porn",
"pornography","porosity","porous","porphyry","porpoise",
"porridge","porringer","port","portable","portage",
"portal","portals","portcullis","portend","portent",
"portentous","porter","porterage","porterhouse","portfolio",
"porthole","portico","portion","portly","portmanteau",
"portrait","portraitist","portraiture","portray","portrayal",
"pose","poser","poseur","posh","posit",
"position","positional","positive","positively","positiveness",
"positivism","positron","posse","possess","possessed",
"possession","possessive","possessor","posset","possibility",
"possible","possibly","possum","post","postage",
"postal","postbag","postbox","postcard","postcode",
"postdate","poster","posterior","posterity","postern",
"postgraduate","posthaste","posthumous","postilion","postillion",
"posting","postman","postmark","postmaster","postmortem",
"postpaid","postpone","postprandial","postscript","postulant",
"postulate","posture","postwar","posy","pot",
"potable","potash","potassium","potation","potato",
"potbellied","potbelly","potboiler","potbound","poteen",
"potency","potent","potentate","potential","potentiality",
"pothead","pother","potherb","pothole","potholing",
"pothouse","pothunter","potion","potluck","potpourri",
"potsherd","potshot","pottage","potted","potter",
"potteries","pottery","potty","pouch","pouf",
"pouffe","poulterer","poultice","poultry","pounce",
"pound","poundage","pounding","pour","pout",
"poverty","powder","powdered","powdery","power",
"powerboat","powerful","powerhouse","powerless","powers",
"powwow","pox","pps","practicable","practical",
"practicality","practically","practice","practiced","practise",
"practised","practitioner","praesidium","praetor","praetorian",
"pragmatic","pragmatism","prairie","praise","praises",
"praiseworthy","praline","pram","prance","prank",
"prankster","prat","prate","pratfall","prattle",
"prawn","praxis","pray","prayer","preach",
"preachify","preamble","prearrange","prebend","prebendary",
"precarious","precast","precaution","precede","precedence",
"precedent","preceding","precentor","precept","preceptor",
"precession","precinct","precincts","preciosity","precious",
"precipice","precipitate","precipitation","precipitous","precise",
"precisely","precision","preclude","precocious","precognition",
"preconceived","preconception","precondition","precook","precursor",
"predator","predatory","predecease","predecessor","predestinate",
"predestination","predestine","predetermine","predeterminer","predicament",
"predicate","predicative","predict","predictable","prediction",
"predigest","predilection","predispose","predisposition","predominance",
"predominant","predominantly","predominate","preeminent","preeminently",
"preempt","preemption","preemptive","preen","preexist",
"preexistence","prefab","prefabricate","prefabricated","preface",
"prefatory","prefect","prefecture","prefer","preferable",
"preference","preferential","preferment","prefigure","prefix",
"pregnancy","pregnant","preheat","prehensile","prehistoric",
"prehistory","prejudge","prejudice","prejudiced","prejudicial",
"prelacy","prelate","prelim","preliminary","prelims",
"preliterate","prelude","premarital","premature","premeditate",
"premeditated","premier","premise","premises","premiss",
"premium","premonition","premonitory","prenatal","prentice",
"preoccupation","preoccupied","preoccupy","preordain","prep",
"prepack","preparation","preparatory","prepare","prepared",
"preparedness","prepay","preponderance","preponderant","preponderate",
"preposition","prepositional","prepossessed","prepossessing","prepossession",
"preposterous","prepuce","prerecord","prerequisite","prerogative",
"presage","presbyter","presbyterian","presbytery","preschool",
"prescient","prescribe","prescribed","prescript","prescription",
"prescriptive","presence","present","presentable","presentation",
"presenter","presentiment","presently","presents","preservable",
"preservation","preservative","preserve","preserver","preset",
"preshrunk","preside","presidency","president","presidential",
"presidium","press","pressed","pressgang","pressing",
"pressman","pressmark","pressure","pressurise","pressurize",
"prestidigitation","prestige","prestigious","prestissimo","presto",
"prestressed","presumable","presume","presumption","presumptive",
"presumptuous","presuppose","presupposition","pretence","pretend",
"pretended","pretender","pretense","pretension","pretentious",
"pretentiousness","preterit","preterite","preternatural","pretext",
"pretor","pretorian","prettify","prettily","pretty",
"pretzel","prevail","prevailing","prevalent","prevaricate",
"prevent","prevention","preventive","preview","previous",
"prevision","prewar","prey","price","priceless",
"pricey","prick","prickle","prickly","pricy",
"pride","priest","priesthood","priestly","prig",
"priggish","prim","primacy","primaeval","primal",
"primarily","primary","primate","prime","primer",
"primeval","priming","primitive","primogeniture","primordial",
"primp","primrose","primula","primus","prince",
"princedom","princely","princess","principal","principality",
"principally","principle","principled","principles","prink",
"print","printable","printer","printing","printout",
"prior","priority","priory","prise","prism",
"prismatic","prison","prisoner","prissy","pristine",
"prithee","privacy","private","privateer","privation",
"privet","privilege","privileged","privily","privy",
"prize","prizefight","prizeman","pro","probability",
"probable","probably","probate","probation","probationer",
"probe","probity","problem","problematic","proboscis",
"procedural","procedure","proceed","proceeding","proceedings",
"proceeds","process","procession","processional","proclaim",
"proclamation","proclivity","proconsul","proconsulate","procrastinate",
"procreate","proctor","procure","procurer","prod",
"prodigal","prodigious","prodigy","produce","producer",
"product","production","productive","productivity","proem",
"prof","profanation","profane","profanity","profess",
"professed","professedly","profession","professional","professionalism",
"professor","professorial","professorship","proffer","proficient",
"profile","profit","profitable","profiteer","profligacy",
"profligate","profound","profundity","profuse","profusion",
"progenitor","progeny","progesterone","prognathous","prognosis",
"prognostic","prognosticate","prognostication","program","programer",
"programmer","progress","progression","progressive","prohibit",
"prohibition","prohibitionist","prohibitive","prohibitory","project",
"projectile","projection","projectionist","projector","prolapse",
"prole","prolegomena","proletarian","proletariat","proliferate",
"proliferation","prolific","prolix","prolog","prologue",
"prolong","prolongation","prolonged","prom","promenade",
"promenader","prominence","prominent","promiscuity","promiscuous",
"promise","promising","promontory","promote","promoter",
"promotion","prompt","prompter","promptness","promulgate",
"pron","prone","prong","pronominal","pronoun",
"pronounce","pronounceable","pronounced","pronouncement","pronto",
"pronunciamento","pronunciation","proof","proofread","prop",
"propaganda","propagandise","propagandist","propagandize","propagate",
"propagation","propane","propel","propellant","propellent",
"propeller","propensity","proper","properly","propertied",
"property","prophecy","prophesy","prophet","prophetess",
"prophetic","prophets","prophylactic","prophylaxis","propinquity",
"propitiate","propitiatory","propitious","propjet","proponent",
"proportion","proportional","proportionate","proportions","proposal",
"propose","proposition","propound","proprietary","proprieties",
"proprietor","proprietress","propriety","propulsion","propulsive",
"propylene","prorogation","prorogue","prosaic","proscenium",
"proscribe","proscription","prose","prosecute","prosecution",
"prosecutor","proselyte","proselytise","proselytize","prosody",
"prospect","prospective","prospector","prospects","prospectus",
"prosper","prosperity","prosperous","prostate","prosthesis",
"prostitute","prostitution","prostrate","prostration","prosy",
"protagonist","protean","protect","protection","protectionism",
"protective","protector","protectorate","protein","protest",
"protestant","protestation","protocol","proton","protoplasm",
"prototype","protozoa","protozoan","protozoon","protract",
"protraction","protractor","protrude","protrusion","protrusive",
"protuberance","protuberant","proud","provable","prove",
"proven","provenance","provender","proverb","proverbial",
"proverbially","proverbs","provide","provided","providence",
"provident","providential","provider","providing","province",
"provinces","provincial","provision","provisional","provisions",
"proviso","provocation","provocative","provoke","provoking",
"provost","prow","prowess","prowl","prowler",
"prox","proximal","proximate","proximity","proximo",
"proxy","prude","prudence","prudent","prudential",
"prudery","prudish","prune","pruning","prurience",
"prurient","pruritus","prussian","pry","psalm",
"psalmist","psalmody","psalms","psalter","psaltery",
"psephology","pseud","pseudonym","pseudonymous","pshaw",
"psittacosis","psoriasis","psst","psyche","psychedelic",
"psychiatric","psychiatrist","psychiatry","psychic","psycho",
"psychoanalyse","psychoanalysis","psychoanalyst","psychoanalytic","psychoanalyze",
"psychokinesis","psychological","psychologist","psychology","psychopath",
"psychosis","psychosomatic","psychotherapy","psychotic","pta",
"ptarmigan","pterodactyl","pto","ptomaine","pub",
"puberty","pubic","public","publican","publication",
"publicise","publicist","publicity","publicize","publish",
"publisher","publishing","puce","puck","pucker",
"puckish","pud","pudding","puddle","pudendum",
"pudgy","pueblo","puerile","puerility","puerperal",
"puff","puffball","puffed","puffer","puffin",
"puffy","pug","pugilism","pugilist","pugnacious",
"pugnacity","puissance","puissant","puke","pukka",
"pulchritude","pulchritudinous","pule","pull","pullback",
"pullet","pulley","pullman","pullout","pullover",
"pullthrough","pullulate","pulmonary","pulp","pulpit",
"pulsar","pulsate","pulsation","pulse","pulverise",
"pulverize","puma","pumice","pummel","pump",
"pumpernickel","pumpkin","pun","punch","punchy",
"punctilio","punctilious","punctual","punctuate","punctuation",
"puncture","pundit","pungent","punic","punish",
"punishable","punishing","punishment","punitive","punjabi",
"punk","punkah","punnet","punster","punt",
"puny","pup","pupa","pupate","pupil",
"puppet","puppeteer","puppy","purblind","purchase",
"purchaser","purdah","pure","pureblooded","purebred",
"puree","purely","pureness","purgation","purgative",
"purgatory","purge","purification","purify","purist",
"puritan","puritanical","purity","purl","purler",
"purlieus","purloin","purple","purplish","purport",
"purpose","purposeful","purposeless","purposely","purposive",
"purr","purse","purser","pursuance","pursue",
"pursuer","pursuit","purulent","purvey","purveyance",
"purveyor","purview","pus","push","pushbike",
"pushcart","pushchair","pushed","pusher","pushover",
"pushy","pusillanimous","puss","pussy","pussycat",
"pussyfoot","pustule","put","putative","putrefaction",
"putrefactive","putrefy","putrescent","putrid","putsch",
"putt","puttee","putter","putto","putty",
"puzzle","puzzlement","puzzler","pvc","pygmy",
"pyjama","pyjamas","pylon","pyorrhea","pyorrhoea",
"pyramid","pyre","pyrex","pyrexia","pyrites",
"pyromania","pyromaniac","pyrotechnic","pyrotechnics","python",
"pyx","qed","qty","qua","quack",
"quackery","quad","quadragesima","quadrangle","quadrangular",
"quadrant","quadrilateral","quadrille","quadrillion","quadroon",
"quadruped","quadruple","quadruplet","quadruplicate","quaff",
"quagga","quagmire","quail","quaint","quake",
"quaker","qualification","qualifications","qualified","qualifier",
"qualify","qualitative","quality","qualm","quandary",
"quantify","quantitative","quantity","quantum","quarantine",
"quark","quarrel","quarrelsome","quarry","quart",
"quarter","quarterdeck","quarterfinal","quartering","quarterly",
"quartermaster","quarters","quarterstaff","quartet","quartette",
"quarto","quartz","quasar","quash","quatercentenary",
"quatrain","quaver","quay","quean","queasy",
"queen","queenly","queer","quell","quench",
"quenchless","querulous","query","quest","question",
"questionable","questioner","questioning","questionnaire","quetzal",
"queue","quibble","quick","quicken","quickie",
"quicklime","quicksand","quicksilver","quickstep","quid",
"quiescent","quiet","quieten","quietism","quietude",
"quietus","quiff","quill","quilt","quilted",
"quin","quince","quinine","quinquagesima","quinsy",
"quintal","quintessence","quintet","quintette","quintuplet",
"quip","quire","quirk","quisling","quit",
"quits","quittance","quitter","quiver","quixotic",
"quiz","quizmaster","quizzical","quod","quoit",
"quoits","quondam","quorum","quota","quotable",
"quotation","quote","quoth","quotidian","quotient",
"rabbi","rabbinical","rabbit","rabble","rabelaisian",
"rabid","rabies","rac","raccoon","race",
"racecourse","racehorse","raceme","racer","races",
"racetrack","racial","racialism","racially","racing",
"rack","racket","racketeer","racketeering","rackets",
"raconteur","racoon","racquet","racquets","racy",
"radar","radial","radiance","radiant","radiate",
"radiation","radiator","radical","radicalise","radicalism",
"radicalize","radicle","radii","radio","radioactive",
"radioactivity","radiogram","radiograph","radiographer","radiography",
"radioisotope","radiolocation","radiology","radiotherapist","radiotherapy",
"radish","radium","radius","raffia","raffish",
"raffle","raft","rafter","raftered","raftsman",
"rag","raga","ragamuffin","ragbag","rage",
"ragged","raglan","ragout","ragtag","ragtime",
"raid","raider","rail","railhead","railing",
"raillery","railroad","rails","railway","raiment",
"rain","rainbow","raincoat","raindrop","rainfall",
"rainproof","rains","rainstorm","rainwater","rainy",
"raise","raisin","raj","raja","rajah",
"rake","rakish","rallentando","rally","ram",
"ramadan","ramble","rambler","rambling","rambunctious",
"ramekin","ramification","ramify","ramjet","ramp",
"rampage","rampant","rampart","ramrod","ramshackle",
"ran","ranch","rancher","rancid","rancor",
"rancorous","rancour","rand","random","randy",
"ranee","rang","range","ranger","rani",
"rank","ranker","ranking","rankle","ranks",
"ransack","ransom","rant","rap","rapacious",
"rapacity","rape","rapid","rapids","rapier",
"rapine","rapist","rapport","rapprochement","rapscallion",
"rapt","rapture","rapturous","rare","rarebit",
"rarefied","rarefy","rarely","raring","rarity",
"rascal","rascally","rash","rasher","rasp",
"raspberry","rat","ratable","ratchet","rate",
"rateable","ratepayer","rather","ratify","rating",
"ratio","ratiocination","ration","rational","rationale",
"rationalise","rationalism","rationalist","rationalize","rations",
"ratlin","ratline","rats","rattan","ratter",
"rattle","rattlebrained","rattlesnake","rattletrap","rattling",
"ratty","raucous","raunchy","ravage","ravages",
"rave","ravel","raven","ravening","ravenous",
"raver","ravine","raving","ravings","ravioli",
"ravish","ravishing","ravishment","raw","rawhide",
"ray","rayon","raze","razor","razorback",
"razzle","reach","react","reaction","reactionary",
"reactivate","reactive","reactor","read","readable",
"readdress","reader","readership","readily","readiness",
"reading","readjust","readout","ready","reafforest",
"reagent","real","realign","realisable","realisation",
"realise","realism","realist","realistic","reality",
"realizable","realization","realize","really","realm",
"realpolitik","realtor","realty","ream","reanimate",
"reap","reaper","reappear","reappraisal","rear",
"rearguard","rearm","rearmament","rearmost","rearrange",
"rearward","rearwards","reason","reasonable","reasonably",
"reasoned","reasoning","reassure","rebarbative","rebate",
"rebel","rebellion","rebellious","rebind","rebirth",
"reborn","rebound","rebuff","rebuild","rebuke",
"rebus","rebut","rebuttal","recalcitrance","recalcitrant",
"recall","recant","recap","recapitulate","recapitulation",
"recapture","recast","recce","recd","recede",
"receipt","receipts","receivable","receive","received",
"receiver","receivership","receiving","recent","recently",
"receptacle","reception","receptionist","receptive","recess",
"recession","recessional","recessive","recharge","recidivist",
"recipe","recipient","reciprocal","reciprocate","reciprocity",
"recital","recitation","recitative","recite","reck",
"reckless","reckon","reckoner","reckoning","reclaim",
"reclamation","recline","recluse","recognise","recognition",
"recognizance","recognize","recoil","recollect","recollection",
"recommend","recommendation","recompense","reconcile","reconciliation",
"recondite","recondition","reconnaissance","reconnoiter","reconnoitre",
"reconsider","reconstitute","reconstruct","reconstruction","record",
"recorder","recording","recordkeeping","recount","recoup",
"recourse","recover","recovery","recreant","recreate",
"recreation","recreational","recriminate","recrimination","recrudescence",
"recruit","rectal","rectangle","rectangular","rectification",
"rectifier","rectify","rectilinear","rectitude","recto",
"rector","rectory","rectum","recumbent","recuperate",
"recuperative","recur","recurrence","recurrent","recurved",
"recusant","recycle","red","redbreast","redbrick",
"redcap","redcoat","redcurrant","redden","reddish",
"redecorate","redeem","redeemer","redemption","redemptive",
"redeploy","redhead","rediffusion","redirect","redistribute",
"redo","redolence","redolent","redouble","redoubt",
"redoubtable","redound","redress","redskin","reduce",
"reduction","redundancy","redundant","reduplicate","redwing",
"redwood","reecho","reed","reeds","reeducate",
"reedy","reef","reefer","reek","reel",
"reentry","reeve","ref","reface","refashion",
"refectory","refer","referee","reference","referendum",
"refill","refine","refined","refinement","refiner",
"refinery","refit","reflate","reflation","reflect",
"reflection","reflective","reflector","reflex","reflexes",
"reflexive","refloat","refoot","reforest","reform",
"reformation","reformatory","refract","refractory","refrain",
"refresh","refresher","refreshing","refreshment","refreshments",
"refrigerant","refrigerate","refrigeration","refrigerator","reft",
"refuel","refuge","refugee","refulgence","refulgent",
"refund","refurbish","refusal","refuse","refutable",
"refutation","refute","regain","regal","regale",
"regalia","regard","regardful","regarding","regardless",
"regards","regatta","regency","regenerate","regent",
"reggae","regicide","regime","regimen","regiment",
"regimental","regimentals","regina","region","regional",
"regions","register","registrar","registration","registry",
"regnant","regress","regressive","regret","regrets",
"regrettable","regrettably","regroup","regular","regularise",
"regularity","regularize","regularly","regulate","regulation",
"regulator","regulo","regurgitate","rehabilitate","rehash",
"rehear","rehearsal","rehearse","rehouse","reich",
"reification","reify","reign","reimburse","reimbursement",
"rein","reincarnate","reincarnation","reindeer","reinforce",
"reinforcement","reinforcements","reins","reinstate","reinsure",
"reissue","reiterate","reject","rejection","rejoice",
"rejoicing","rejoicings","rejoin","rejoinder","rejuvenate",
"rekindle","relaid","relapse","relate","related",
"relation","relational","relations","relationship","relative",
"relatively","relativism","relativistic","relativity","relax",
"relaxation","relaxing","relay","release","relegate",
"relent","relentless","relevance","relevant","reliability",
"reliable","reliance","reliant","relic","relics",
"relict","relief","relieve","relieved","religion",
"religious","religiously","reline","relinquish","reliquary",
"relish","relive","reload","relocate","reluctance",
"reluctant","reluctantly","rely","remain","remainder",
"remains","remake","remand","remark","remarkable",
"remarkably","remarry","remediable","remedial","remedy",
"remember","remembrance","remilitarise","remilitarize","remind",
"reminder","reminisce","reminiscence","reminiscences","reminiscent",
"remiss","remission","remit","remittance","remittent",
"remnant","remodel","remold","remonstrance","remonstrate",
"remorse","remorseful","remote","remotely","remould",
"remount","removal","remove","remover","remunerate",
"remunerative","renaissance","renal","rename","renascent",
"rend","render","rendering","rendezvous","rendition",
"renegade","renege","renegue","renew","renewable",
"renewal","rennet","renounce","renovate","renown",
"renowned","rent","rental","renter","rentier",
"renunciation","reopen","reorganise","reorganize","rep",
"repaid","repair","reparable","reparation","reparations",
"repartee","repast","repatriate","repay","repayable",
"repayment","repeal","repeat","repeated","repeatedly",
"repeater","repeating","repel","repellent","repent",
"repentance","repentant","repercussion","repertoire","repertory",
"repetition","repetitious","repine","replace","replacement",
"replay","replenish","replete","repletion","replica",
"replicate","reply","repoint","report","reportage",
"reportedly","reporter","repose","repository","repossess",
"repot","repp","reprehend","reprehensible","represent",
"representation","representational","representations","representative","repress",
"repressed","repression","repressive","reprieve","reprimand",
"reprint","reprisal","reprise","reproach","reprobate",
"reproduce","reproducer","reproduction","reproductive","reproof",
"reprove","reproving","reptile","reptilian","republic",
"republican","republicanism","repudiate","repugnance","repugnant",
"repulse","repulsion","repulsive","reputable","reputation",
"repute","reputed","reputedly","request","requiem",
"require","requirement","requisite","requisition","requital",
"requite","reredos","rerun","rescind","rescript",
"rescue","research","reseat","resemblance","resemble",
"resent","resentment","reservation","reserve","reserved",
"reservedly","reservist","reservoir","reset","resettle",
"reshuffle","reside","residence","residency","resident",
"residential","residual","residuary","residue","resign",
"resignation","resigned","resilience","resilient","resin",
"resinated","resist","resistance","resistant","resistor",
"resole","resolute","resolution","resolvable","resolve",
"resonance","resonant","resonate","resonator","resort",
"resound","resounding","resource","resourceful","resources",
"respect","respectability","respectable","respecter","respectful",
"respecting","respective","respectively","respects","respiration",
"respirator","respiratory","respire","respite","resplendence",
"resplendent","respond","respondent","response","responsibility",
"responsible","responsibly","responsive","rest","restage",
"restate","restaurant","restaurateur","restful","restitution",
"restive","restless","restock","restoration","restorative",
"restore","restorer","restrain","restrained","restraint",
"restrict","restricted","restriction","restrictive","restructure",
"result","resultant","resume","resumption","resurface",
"resurgence","resurgent","resurrect","resurrection","resuscitate",
"retail","retailer","retain","retainer","retake",
"retaliate","retaliation","retaliatory","retard","retarded",
"retch","retd","retell","retention","retentive",
"rethink","reticence","reticent","reticulated","reticulation",
"reticule","retina","retinue","retire","retired",
"retirement","retiring","retort","retouch","retrace",
"retract","retractable","retractile","retraction","retread",
"retreat","retrench","retrial","retraining","retribution",
"retributive","retrieval","retrieve","retriever","retroactive",
"retroflex","retrograde","retrogress","retrogressive","retrospect",
"retrospection","retrospective","retroversion","retsina","return",
"returnable","returns","reunion","reunite","reuse",
"rev","revalue","revamp","reveal","revealing",
"reveille","revel","revelation","revelry","revenge",
"revenue","reverberant","reverberate","reverberation","revere",
"reverence","reverend","reverent","reverential","reverie",
"revers","reversal","reverse","reversion","reversionary",
"revert","revetment","review","reviewer","revile",
"revise","revision","revisionism","revitalise","revitalize",
"revival","revivalist","revive","revivify","revocable",
"revocation","revoke","revolt","revolting","revolution",
"revolutionary","revolutionise","revolutionize","revolve","revolver",
"revolving","revue","revulsion","reward","rewarding",
"rewards","rewire","reword","rewrite","rex",
"rhapsodise","rhapsodize","rhapsody","rhea","rhenish",
"rheostat","rhetoric","rhetorical","rhetorically","rhetorician",
"rheum","rheumatic","rheumaticky","rheumatics","rheumatism",
"rheumatoid","rhinestone","rhinoceros","rhizome","rhododendron",
"rhomboid","rhombus","rhubarb","rhyme","rhymed",
"rhymester","rhythm","rhythmic","rib","ribald",
"ribaldry","ribbed","ribbing","ribbon","riboflavin",
"rice","rich","riches","richly","richness",
"rick","rickets","rickety","ricksha","rickshaw",
"ricochet","rid","riddance","ridden","riddle",
"ride","rider","riderless","ridge","ridgepole",
"ridicule","ridiculous","riding","riesling","rife",
"riff","riffle","riffraff","rifle","rifleman",
"rifles","rifling","rift","rig","rigging",
"right","righteous","rightful","rightist","rightly",
"rights","rightward","rightwards","rigid","rigidity",
"rigmarole","rigor","rigorous","rigour","rile",
"rill","rim","rime","rind","rinderpest",
"ring","ringer","ringleader","ringlet","ringmaster",
"ringside","ringworm","rink","rinse","riot",
"riotous","rip","riparian","ripcord","ripen",
"riposte","ripple","ripsaw","riptide","rise",
"riser","risibility","risible","rising","risk",
"risky","risotto","rissole","rite","ritual",
"ritualism","ritzy","rival","rivalry","rive",
"river","riverbed","riverside","rivet","riveter",
"riveting","riviera","rivulet","rna","roach",
"road","roadbed","roadblock","roadhouse","roadman",
"roadside","roadstead","roadster","roadway","roadworthy",
"roam","roan","roar","roaring","roast",
"roaster","roasting","rob","robber","robbery",
"robe","robin","robot","robust","rock",
"rockbound","rocker","rockery","rocket","rocketry",
"rocks","rocky","rococo","rod","rode",
"rodent","rodeo","rodomontade","roe","roebuck",
"rogation","roger","rogue","roguery","roguish",
"roisterer","role","roll","roller","rollicking",
"rolling","rolls","romaic","roman","romance",
"romanesque","romantic","romanticise","romanticism","romanticize",
"romany","romish","romp","romper","rompers",
"rondeau","rondo","roneo","rood","roodscreen",
"roof","roofing","roofless","rooftree","rook",
"rookery","rookie","room","roomer","roommate",
"rooms","roomy","roost","rooster","root",
"rooted","rootless","roots","rope","ropedancer",
"ropes","ropewalk","ropeway","ropey","ropy",
"roquefort","rosary","rose","roseate","rosebud",
"roseleaf","rosemary","rosette","rosewater","rosewood",
"rosin","roster","rostrum","rosy","rot",
"rota","rotary","rotate","rotation","rotatory",
"rotgut","rotisserie","rotogravure","rotor","rotten",
"rottenly","rotter","rotund","rotunda","rouble",
"rouge","rough","roughage","roughcast","roughen",
"roughhouse","roughly","roughneck","roughness","roughrider",
"roughshod","roulette","round","roundabout","roundel",
"roundelay","rounders","roundhead","roundhouse","roundish",
"roundly","rounds","roundsman","roundup","roup",
"rouse","rousing","roustabout","rout","route",
"routine","roux","rove","rover","row",
"rowan","rowanberry","rowdy","rowdyism","rowel",
"rower","rowing","rowlock","royal","royalist",
"royalty","rpm","rsm","rsvp","rub",
"rubber","rubberise","rubberize","rubberneck","rubbery",
"rubbing","rubbish","rubbishy","rubble","rubdown",
"rubella","rubicon","rubicund","ruble","rubric",
"ruby","ruck","rucksack","ruckus","ruction",
"ructions","rudder","ruddle","ruddy","rude",
"rudely","rudiment","rudimentary","rudiments","rue",
"rueful","ruff","ruffian","ruffianly","ruffle",
"rug","rugby","rugged","ruin","ruination",
"ruinous","ruins","rule","rulebook","ruler",
"ruling","rum","rumba","rumble","rumbling",
"rumbustious","ruminant","ruminate","ruminative","rummage",
"rummy","rumor","rumored","rumormonger","rumour",
"rumoured","rumourmonger","rump","rumple","rumpus",
"run","runaway","rung","runnel","runner",
"running","runny","runs","runt","runway",
};
}
